
## 建表语句

1. 用户表
```sql
CREATE TABLE user (
    id                        INTEGER   PRIMARY KEY,    -- 物理主键
    username                  TEXT (80) NOT NULL        
                                        UNIQUE,         -- 用户名
    password                  TEXT,                     -- 密码
    name                      TEXT (60) NOT NULL,       -- 姓名
    mobile_phone              TEXT (20),                -- 手机号
    is_enabled                INTEGER   NOT NULL        -- 是否启用：1 (启用)，0（禁用）
                                        DEFAULT (1),
    is_locked                 INTEGER   DEFAULT (0),    -- 是否被冻结：1 (冻结)，0（未冻结）
    account_expiry_time       REAL,                     -- 账号过期时间
    password_last_update_time REAL      NOT NULL        -- 密码的最后修改时间
);
```

2. 权限表
```sql
CREATE TABLE authority (
    name  TEXT (80) NOT NULL,           -- 权限英文名称（主键）
    title TEXT (80),                    -- 权限中文名称，即界面显示名称
    type  TEXT (30) DEFAULT ('ROLE')    -- 权限类型，有 ROLE 和 ORGANIZE 两类, 即角色和组织
                    NOT NULL,
    PRIMARY KEY (
        name
    )
);
```

3. 用户权限表
```sql
CREATE TABLE user_authority_relation (
    user_id         INTEGER,     -- 用户ID
    authority_name  TEXT(80),    -- 权限ID
    PRIMARY KEY (
        user_id ASC,
        authority_id ASC
    )
);
```